/**
 */
package de.mdelab.mlcallactions;

import de.mdelab.mlexpressions.MLExpression;
import java.util.Map;
import org.eclipse.emf.common.util.DiagnosticChain;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Method Call Action</b></em>'. <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Invokes a method using Java's reflection mechanism. If it is not a static method, a value for the implicit this parameter is required. The result of thisParameterValue is used for this purpose.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link de.mdelab.mlcallactions.MethodCallAction#getMethodName <em>Method Name</em>}</li>
 *   <li>{@link de.mdelab.mlcallactions.MethodCallAction#getMethodClassName <em>Method Class Name</em>}</li>
 *   <li>{@link de.mdelab.mlcallactions.MethodCallAction#getThisParameterValue <em>This Parameter Value</em>}</li>
 * </ul>
 *
 * @see de.mdelab.mlcallactions.MlcallactionsPackage#getMethodCallAction()
 * @model annotation="http://www.eclipse.org/emf/2002/Ecore constraints='methodNameSpecified'"
 * @generated
 */
public interface MethodCallAction extends ParameterizedCallAction {
	/**
	 * Returns the value of the '<em><b>Method Name</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc --> The
	 * name of the method to invoke. <!-- end-model-doc -->
	 * 
	 * @return the value of the '<em>Method Name</em>' attribute.
	 * @see #setMethodName(String)
	 * @see de.mdelab.mlcallactions.MlcallactionsPackage#getMethodCallAction_MethodName()
	 * @model required="true"
	 * @generated
	 */
	String getMethodName();

	/**
	 * Sets the value of the '{@link de.mdelab.mlcallactions.MethodCallAction#getMethodName <em>Method Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @param value the new value of the '<em>Method Name</em>' attribute.
	 * @see #getMethodName()
	 * @generated
	 */
	void setMethodName(String value);

	/**
	 * Returns the value of the '<em><b>Method Class Name</b></em>' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc -->
	 * The class that contains the method to invoke. <!-- end-model-doc -->
	 * 
	 * @return the value of the '<em>Method Class Name</em>' attribute.
	 * @see #setMethodClassName(String)
	 * @see de.mdelab.mlcallactions.MlcallactionsPackage#getMethodCallAction_MethodClassName()
	 * @model required="true"
	 * @generated
	 */
	String getMethodClassName();

	/**
	 * Sets the value of the '{@link de.mdelab.mlcallactions.MethodCallAction#getMethodClassName <em>Method Class Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @param value the new value of the '<em>Method Class Name</em>' attribute.
	 * @see #getMethodClassName()
	 * @generated
	 */
	void setMethodClassName(String value);

	/**
	 * Returns the value of the '<em><b>This Parameter Value</b></em>'
	 * containment reference. <!-- begin-user-doc --> <!-- end-user-doc --> <!--
	 * begin-model-doc --> If the method is not static, the result of
	 * thisParameterValue is used as the "this" parameter. <!-- end-model-doc
	 * -->
	 * 
	 * @return the value of the '<em>This Parameter Value</em>' containment
	 *         reference.
	 * @see #setThisParameterValue(MLExpression)
	 * @see de.mdelab.mlcallactions.MlcallactionsPackage#getMethodCallAction_ThisParameterValue()
	 * @model containment="true"
	 * @generated
	 */
	MLExpression getThisParameterValue();

	/**
	 * Sets the value of the '
	 * {@link de.mdelab.mlcallactions.MethodCallAction#getThisParameterValue
	 * <em>This Parameter Value</em>}' containment reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>This Parameter Value</em>'
	 *            containment reference.
	 * @see #getThisParameterValue()
	 * @generated
	 */
	void setThisParameterValue(MLExpression value);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model annotation="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot body='Tuple {\n\tmessage : String = \'methodClassName must be specified.\',\n\tstatus : Boolean = \n\t\tself.methodClassName &lt;&gt; null and self.methodClassName &lt;&gt; \'\'\n}.status'"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='final &lt;%java.lang.String%&gt; constraintName = \"MethodCallAction::methodClassNameSpecified\";\ntry {\n\t/**\n\t *\n\t * inv methodClassNameSpecified:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity &lt;= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let status : Boolean[?] = self.methodClassName &lt;&gt; null and self.methodClassName &lt;&gt; \'\'\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'methodClassName must be specified.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t \052/\n\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.evaluation.Executor%&gt; executor = &lt;%org.eclipse.ocl.pivot.utilities.PivotUtil%&gt;.getExecutor(this, context);\n\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.values.IntegerValue%&gt; severity_0 = &lt;%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%&gt;.INSTANCE.evaluate(executor, &lt;%de.mdelab.mlcallactions.MlcallactionsPackage%&gt;.Literals.METHOD_CALL_ACTION___METHOD_CLASS_NAME_SPECIFIED__DIAGNOSTICCHAIN_MAP);\n\tfinal /*@NonInvalid\052/ boolean le = &lt;%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%&gt;.INSTANCE.evaluate(executor, severity_0, &lt;%de.mdelab.mlcallactions.MlcallactionsTables%&gt;.INT_0).booleanValue();\n\t/*@NonInvalid\052/ boolean symbol_2;\n\tif (le) {\n\t\tsymbol_2 = true;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid\052/ &lt;%java.lang.Boolean%&gt; status;\n\t\tfinal /*@NonInvalid\052/ &lt;%java.lang.String%&gt; methodClassName = this.getMethodClassName();\n\t\tfinal /*@NonInvalid\052/ boolean ne = !methodClassName.equals(&lt;%de.mdelab.mlcallactions.MlcallactionsTables%&gt;.STR_);\n\t\tstatus = ne;\n\t\tfinal /*@NonInvalid\052/ boolean eq = status == Boolean.TRUE;\n\t\t/*@NonInvalid\052/ &lt;%java.lang.Object%&gt; symbol_1;\n\t\tif (eq) {\n\t\t\tsymbol_1 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.values.TupleValue%&gt; symbol_0 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.createTupleOfEach(&lt;%de.mdelab.mlcallactions.MlcallactionsTables%&gt;.TUPLid_, &lt;%de.mdelab.mlcallactions.MlcallactionsTables%&gt;.STR_methodClassName_32_must_32_be_32_specified, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid\052/ boolean logDiagnostic = &lt;%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%&gt;.INSTANCE.evaluate(executor, &lt;%org.eclipse.ocl.pivot.ids.TypeId%&gt;.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_1, &lt;%de.mdelab.mlcallactions.MlcallactionsTables%&gt;.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn symbol_2;\n}\ncatch (&lt;%java.lang.Throwable%&gt; e) {\n\treturn &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}'"
	 * @generated
	 */
	boolean methodClassNameSpecified(DiagnosticChain diagnostics, Map<Object, Object> context);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model annotation="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot body='Tuple {\n\tmessage : String = \'methodName must be specified.\',\n\tstatus : Boolean = \n\t\tself.methodName &lt;&gt; null and self.methodName &lt;&gt; \'\'\n}.status'"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='final &lt;%java.lang.String%&gt; constraintName = \"MethodCallAction::methodNameSpecified\";\ntry {\n\t/**\n\t *\n\t * inv methodNameSpecified:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity &lt;= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let status : Boolean[?] = self.methodName &lt;&gt; null and self.methodName &lt;&gt; \'\'\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'methodName must be specified.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t \052/\n\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.evaluation.Executor%&gt; executor = &lt;%org.eclipse.ocl.pivot.utilities.PivotUtil%&gt;.getExecutor(this, context);\n\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.values.IntegerValue%&gt; severity_0 = &lt;%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%&gt;.INSTANCE.evaluate(executor, &lt;%de.mdelab.mlcallactions.MlcallactionsPackage%&gt;.Literals.METHOD_CALL_ACTION___METHOD_NAME_SPECIFIED__DIAGNOSTICCHAIN_MAP);\n\tfinal /*@NonInvalid\052/ boolean le = &lt;%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%&gt;.INSTANCE.evaluate(executor, severity_0, &lt;%de.mdelab.mlcallactions.MlcallactionsTables%&gt;.INT_0).booleanValue();\n\t/*@NonInvalid\052/ boolean symbol_2;\n\tif (le) {\n\t\tsymbol_2 = true;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid\052/ &lt;%java.lang.Boolean%&gt; status;\n\t\tfinal /*@NonInvalid\052/ &lt;%java.lang.String%&gt; methodName = this.getMethodName();\n\t\tfinal /*@NonInvalid\052/ boolean ne = !methodName.equals(&lt;%de.mdelab.mlcallactions.MlcallactionsTables%&gt;.STR_);\n\t\tstatus = ne;\n\t\tfinal /*@NonInvalid\052/ boolean eq = status == Boolean.TRUE;\n\t\t/*@NonInvalid\052/ &lt;%java.lang.Object%&gt; symbol_1;\n\t\tif (eq) {\n\t\t\tsymbol_1 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.values.TupleValue%&gt; symbol_0 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.createTupleOfEach(&lt;%de.mdelab.mlcallactions.MlcallactionsTables%&gt;.TUPLid_, &lt;%de.mdelab.mlcallactions.MlcallactionsTables%&gt;.STR_methodName_32_must_32_be_32_specified, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid\052/ boolean logDiagnostic = &lt;%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%&gt;.INSTANCE.evaluate(executor, &lt;%org.eclipse.ocl.pivot.ids.TypeId%&gt;.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_1, &lt;%de.mdelab.mlcallactions.MlcallactionsTables%&gt;.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn symbol_2;\n}\ncatch (&lt;%java.lang.Throwable%&gt; e) {\n\treturn &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}'"
	 * @generated
	 */
	boolean methodNameSpecified(DiagnosticChain diagnostics, Map<Object, Object> context);

} // MethodCallAction
