/**
 */
package de.mdelab.mlcallactions;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Parameterized Call Action</b></em>'. <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Superclass for call actions that may have parameters.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link de.mdelab.mlcallactions.ParameterizedCallAction#getParameters <em>Parameters</em>}</li>
 * </ul>
 *
 * @see de.mdelab.mlcallactions.MlcallactionsPackage#getParameterizedCallAction()
 * @model abstract="true"
 * @generated
 */
public interface ParameterizedCallAction extends CallAction {
	/**
	 * Returns the value of the '<em><b>Parameters</b></em>' containment reference list.
	 * The list contents are of type {@link de.mdelab.mlcallactions.CallActionParameter}.
	 * It is bidirectional and its opposite is '{@link de.mdelab.mlcallactions.CallActionParameter#getCallAction <em>Call Action</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Parameters</em>' containment reference list
	 * isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Parameters</em>' containment reference list.
	 * @see de.mdelab.mlcallactions.MlcallactionsPackage#getParameterizedCallAction_Parameters()
	 * @see de.mdelab.mlcallactions.CallActionParameter#getCallAction
	 * @model opposite="callAction" containment="true"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel get='throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlexpressions/mlcallactions/1.0!ParameterizedCallAction!parameters'"
	 * @generated
	 */
	EList<CallActionParameter> getParameters();

} // ParameterizedCallAction
