/**
 */
package de.mdelab.mlcallactions.impl;

import de.mdelab.mlcallactions.*;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.impl.EFactoryImpl;
import org.eclipse.emf.ecore.plugin.EcorePlugin;

import de.mdelab.mlcallactions.BinaryOperationAction;
import de.mdelab.mlcallactions.BinaryOperatorsEnum;
import de.mdelab.mlcallactions.CallActionExpression;
import de.mdelab.mlcallactions.CallActionParameter;
import de.mdelab.mlcallactions.CloneAction;
import de.mdelab.mlcallactions.EObjectReferenceAction;
import de.mdelab.mlcallactions.EOperationCallAction;
import de.mdelab.mlcallactions.LiteralDeclarationAction;
import de.mdelab.mlcallactions.MethodCallAction;
import de.mdelab.mlcallactions.MlcallactionsFactory;
import de.mdelab.mlcallactions.MlcallactionsPackage;
import de.mdelab.mlcallactions.NewObjectAction;
import de.mdelab.mlcallactions.NullValueAction;
import de.mdelab.mlcallactions.UnaryOperationAction;
import de.mdelab.mlcallactions.UnaryOperatorsEnum;
import de.mdelab.mlcallactions.VariableDeclarationAction;
import de.mdelab.mlcallactions.VariableReferenceAction;

/**
 * <!-- begin-user-doc --> An implementation of the model <b>Factory</b>. <!--
 * end-user-doc -->
 * @generated
 */
public class MlcallactionsFactoryImpl extends EFactoryImpl implements MlcallactionsFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	public static MlcallactionsFactory init() {
		try {
			MlcallactionsFactory theMlcallactionsFactory = (MlcallactionsFactory) EPackage.Registry.INSTANCE
					.getEFactory(MlcallactionsPackage.eNS_URI);
			if (theMlcallactionsFactory != null) {
				return theMlcallactionsFactory;
			}
		} catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new MlcallactionsFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	public MlcallactionsFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
		case MlcallactionsPackage.CALL_ACTION_EXPRESSION:
			return createCallActionExpression();
		case MlcallactionsPackage.LITERAL_DECLARATION_ACTION:
			return createLiteralDeclarationAction();
		case MlcallactionsPackage.VARIABLE_DECLARATION_ACTION:
			return createVariableDeclarationAction();
		case MlcallactionsPackage.VARIABLE_REFERENCE_ACTION:
			return createVariableReferenceAction();
		case MlcallactionsPackage.NULL_VALUE_ACTION:
			return createNullValueAction();
		case MlcallactionsPackage.UNARY_OPERATION_ACTION:
			return createUnaryOperationAction();
		case MlcallactionsPackage.BINARY_OPERATION_ACTION:
			return createBinaryOperationAction();
		case MlcallactionsPackage.CLONE_ACTION:
			return createCloneAction();
		case MlcallactionsPackage.CALL_ACTION_PARAMETER:
			return createCallActionParameter();
		case MlcallactionsPackage.METHOD_CALL_ACTION:
			return createMethodCallAction();
		case MlcallactionsPackage.EOPERATION_CALL_ACTION:
			return createEOperationCallAction();
		case MlcallactionsPackage.NEW_OBJECT_ACTION:
			return createNewObjectAction();
		case MlcallactionsPackage.EOBJECT_REFERENCE_ACTION:
			return createEObjectReferenceAction();
		default:
			throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object createFromString(EDataType eDataType, String initialValue) {
		switch (eDataType.getClassifierID()) {
		case MlcallactionsPackage.UNARY_OPERATORS_ENUM:
			return createUnaryOperatorsEnumFromString(eDataType, initialValue);
		case MlcallactionsPackage.BINARY_OPERATORS_ENUM:
			return createBinaryOperatorsEnumFromString(eDataType, initialValue);
		default:
			throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String convertToString(EDataType eDataType, Object instanceValue) {
		switch (eDataType.getClassifierID()) {
		case MlcallactionsPackage.UNARY_OPERATORS_ENUM:
			return convertUnaryOperatorsEnumToString(eDataType, instanceValue);
		case MlcallactionsPackage.BINARY_OPERATORS_ENUM:
			return convertBinaryOperatorsEnumToString(eDataType, instanceValue);
		default:
			throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public CallActionExpression createCallActionExpression() {
		CallActionExpressionImpl callActionExpression = new CallActionExpressionImpl();
		return callActionExpression;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public LiteralDeclarationAction createLiteralDeclarationAction() {
		LiteralDeclarationActionImpl literalDeclarationAction = new LiteralDeclarationActionImpl();
		return literalDeclarationAction;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public VariableDeclarationAction createVariableDeclarationAction() {
		VariableDeclarationActionImpl variableDeclarationAction = new VariableDeclarationActionImpl();
		return variableDeclarationAction;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public VariableReferenceAction createVariableReferenceAction() {
		VariableReferenceActionImpl variableReferenceAction = new VariableReferenceActionImpl();
		return variableReferenceAction;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullValueAction createNullValueAction() {
		NullValueActionImpl nullValueAction = new NullValueActionImpl();
		return nullValueAction;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public UnaryOperationAction createUnaryOperationAction() {
		UnaryOperationActionImpl unaryOperationAction = new UnaryOperationActionImpl();
		return unaryOperationAction;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public BinaryOperationAction createBinaryOperationAction() {
		BinaryOperationActionImpl binaryOperationAction = new BinaryOperationActionImpl();
		return binaryOperationAction;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public CloneAction createCloneAction() {
		CloneActionImpl cloneAction = new CloneActionImpl();
		return cloneAction;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public CallActionParameter createCallActionParameter() {
		CallActionParameterImpl callActionParameter = new CallActionParameterImpl();
		return callActionParameter;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public MethodCallAction createMethodCallAction() {
		MethodCallActionImpl methodCallAction = new MethodCallActionImpl();
		return methodCallAction;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperationCallAction createEOperationCallAction() {
		EOperationCallActionImpl eOperationCallAction = new EOperationCallActionImpl();
		return eOperationCallAction;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NewObjectAction createNewObjectAction() {
		NewObjectActionImpl newObjectAction = new NewObjectActionImpl();
		return newObjectAction;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObjectReferenceAction createEObjectReferenceAction() {
		EObjectReferenceActionImpl eObjectReferenceAction = new EObjectReferenceActionImpl();
		return eObjectReferenceAction;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public UnaryOperatorsEnum createUnaryOperatorsEnumFromString(EDataType eDataType, String initialValue) {
		UnaryOperatorsEnum result = UnaryOperatorsEnum.get(initialValue);
		if (result == null)
			throw new IllegalArgumentException(
					"The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public String convertUnaryOperatorsEnumToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public BinaryOperatorsEnum createBinaryOperatorsEnumFromString(EDataType eDataType, String initialValue) {
		BinaryOperatorsEnum result = BinaryOperatorsEnum.get(initialValue);
		if (result == null)
			throw new IllegalArgumentException(
					"The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public String convertBinaryOperatorsEnumToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public MlcallactionsPackage getMlcallactionsPackage() {
		return (MlcallactionsPackage) getEPackage();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static MlcallactionsPackage getPackage() {
		return MlcallactionsPackage.eINSTANCE;
	}

} // MlcallactionsFactoryImpl
