/**
 */
package de.mdelab.mlcallactions.impl;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.ocl.pivot.evaluation.Executor;
import org.eclipse.ocl.pivot.ids.IdResolver;
import org.eclipse.ocl.pivot.ids.TypeId;
import org.eclipse.ocl.pivot.library.oclany.OclAnyOclAsTypeOperation;
import org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsKindOfOperation;
import org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation;
import org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation;
import org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation;
import org.eclipse.ocl.pivot.utilities.PivotUtil;
import org.eclipse.ocl.pivot.utilities.ValueUtil;
import org.eclipse.ocl.pivot.values.IntegerValue;
import org.eclipse.ocl.pivot.values.InvalidValueException;
import org.eclipse.ocl.pivot.values.TupleValue;
import de.mdelab.mlcallactions.MlcallactionsPackage;
import de.mdelab.mlcallactions.MlcallactionsTables;
import de.mdelab.mlcallactions.NewObjectAction;
import java.lang.reflect.InvocationTargetException;
import java.util.Map;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>New Object Action</b></em>'. <!-- end-user-doc -->
 *
 * @generated
 */
public class NewObjectActionImpl extends ParameterizedCallActionImpl implements NewObjectAction {
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected NewObjectActionImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MlcallactionsPackage.Literals.NEW_OBJECT_ACTION;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean typeSpecified(final DiagnosticChain diagnostics, final Map<Object, Object> context) {
		final String constraintName = "NewObjectAction::typeSpecified";
		try {
			/**
			 *
			 * inv typeSpecified:
			 *   let severity : Integer[1] = constraintName.getSeverity()
			 *   in
			 *     if severity <= 0
			 *     then true
			 *     else
			 *       let
			 *         result : OclAny[1] = let status : Boolean[1] = self.type <> null
			 *         in
			 *           if status = true
			 *           then true
			 *           else Tuple{message = 'type must be specified.', status = status}
			 *           endif
			 *       in
			 *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
			 *     endif
			 */
			final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this, context);
			final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE.evaluate(executor,
					MlcallactionsPackage.Literals.NEW_OBJECT_ACTION___TYPE_SPECIFIED__DIAGNOSTICCHAIN_MAP);
			final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
					.evaluate(executor, severity_0, MlcallactionsTables.INT_0).booleanValue();
			/*@NonInvalid*/ boolean symbol_2;
			if (le) {
				symbol_2 = true;
			} else {
				final /*@NonInvalid*/ EClassifier type = this.getType();
				final /*@NonInvalid*/ boolean status = type != null;
				/*@NonInvalid*/ Object symbol_1;
				if (status) {
					symbol_1 = ValueUtil.TRUE_VALUE;
				} else {
					final /*@NonInvalid*/ TupleValue symbol_0 = ValueUtil.createTupleOfEach(MlcallactionsTables.TUPLid_,
							MlcallactionsTables.STR_type_32_must_32_be_32_specified, status);
					symbol_1 = symbol_0;
				}
				final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
						.evaluate(executor, TypeId.BOOLEAN, constraintName, this, (Object) null, diagnostics, context,
								(Object) null, severity_0, symbol_1, MlcallactionsTables.INT_0)
						.booleanValue();
				symbol_2 = logDiagnostic;
			}
			return symbol_2;
		} catch (Throwable e) {
			return ValueUtil.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean typeNotAbstract(final DiagnosticChain diagnostics, final Map<Object, Object> context) {
		final String constraintName = "NewObjectAction::typeNotAbstract";
		try {
			/**
			 *
			 * inv typeNotAbstract:
			 *   let severity : Integer[1] = constraintName.getSeverity()
			 *   in
			 *     if severity <= 0
			 *     then true
			 *     else
			 *       let
			 *         result : OclAny[1] = let
			 *           status : Boolean[?] = if self.type <> null
			 *           then
			 *             if self.type.oclIsKindOf(ecore::EClass)
			 *             then not self.type.oclAsType(ecore::EClass).abstract
			 *             else null
			 *             endif
			 *           else null
			 *           endif
			 *         in
			 *           if status = true
			 *           then true
			 *           else Tuple{message = 'type must not be abstract.', status = status}
			 *           endif
			 *       in
			 *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
			 *     endif
			 */
			final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this, context);
			final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
			final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE.evaluate(executor,
					MlcallactionsPackage.Literals.NEW_OBJECT_ACTION___TYPE_NOT_ABSTRACT__DIAGNOSTICCHAIN_MAP);
			final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
					.evaluate(executor, severity_0, MlcallactionsTables.INT_0).booleanValue();
			/*@NonInvalid*/ boolean symbol_4;
			if (le) {
				symbol_4 = true;
			} else {
				/*@Caught*/ Object CAUGHT_symbol_3;
				try {
					final /*@NonInvalid*/ EClassifier type = this.getType();
					final /*@NonInvalid*/ boolean ne = type != null;
					/*@Thrown*/ Boolean status;
					if (ne) {
						final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_ecore_c_c_EClass = idResolver
								.getClass(MlcallactionsTables.CLSSid_EClass, null);
						final /*@Thrown*/ boolean oclIsKindOf = OclAnyOclIsKindOfOperation.INSTANCE
								.evaluate(executor, type, TYP_ecore_c_c_EClass).booleanValue();
						/*@Thrown*/ Boolean symbol_1;
						if (oclIsKindOf) {
							/*@Caught*/ Object CAUGHT_symbol_0;
							try {
								final /*@Thrown*/ EClass oclAsType = (EClass) OclAnyOclAsTypeOperation.INSTANCE
										.evaluate(executor, type, TYP_ecore_c_c_EClass);
								final /*@Thrown*/ boolean symbol_0 = oclAsType.isAbstract();
								CAUGHT_symbol_0 = symbol_0;
							} catch (Exception e) {
								CAUGHT_symbol_0 = ValueUtil.createInvalidValue(e);
							}
							if (CAUGHT_symbol_0 instanceof InvalidValueException) {
								throw (InvalidValueException) CAUGHT_symbol_0;
							}
							final /*@Thrown*/ Boolean not;
							if (CAUGHT_symbol_0 == ValueUtil.FALSE_VALUE) {
								not = ValueUtil.TRUE_VALUE;
							} else {
								if (CAUGHT_symbol_0 == ValueUtil.TRUE_VALUE) {
									not = ValueUtil.FALSE_VALUE;
								} else {
									not = null;
								}
							}
							symbol_1 = not;
						} else {
							symbol_1 = null;
						}
						status = symbol_1;
					} else {
						status = null;
					}
					final /*@Thrown*/ boolean eq = status == Boolean.TRUE;
					/*@Thrown*/ Object symbol_3;
					if (eq) {
						symbol_3 = ValueUtil.TRUE_VALUE;
					} else {
						final /*@Thrown*/ TupleValue symbol_2 = ValueUtil.createTupleOfEach(MlcallactionsTables.TUPLid_,
								MlcallactionsTables.STR_type_32_must_32_not_32_be_32_abstract, status);
						symbol_3 = symbol_2;
					}
					CAUGHT_symbol_3 = symbol_3;
				} catch (Exception e) {
					CAUGHT_symbol_3 = ValueUtil.createInvalidValue(e);
				}
				final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
						.evaluate(executor, TypeId.BOOLEAN, constraintName, this, (Object) null, diagnostics, context,
								(Object) null, severity_0, CAUGHT_symbol_3, MlcallactionsTables.INT_0)
						.booleanValue();
				symbol_4 = logDiagnostic;
			}
			return symbol_4;
		} catch (Throwable e) {
			return ValueUtil.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	@SuppressWarnings("unchecked")
	public Object eInvoke(int operationID, EList<?> arguments) throws InvocationTargetException {
		switch (operationID) {
		case MlcallactionsPackage.NEW_OBJECT_ACTION___TYPE_SPECIFIED__DIAGNOSTICCHAIN_MAP:
			return typeSpecified((DiagnosticChain) arguments.get(0), (Map<Object, Object>) arguments.get(1));
		case MlcallactionsPackage.NEW_OBJECT_ACTION___TYPE_NOT_ABSTRACT__DIAGNOSTICCHAIN_MAP:
			return typeNotAbstract((DiagnosticChain) arguments.get(0), (Map<Object, Object>) arguments.get(1));
		}
		return super.eInvoke(operationID, arguments);
	}

} // NewObjectActionImpl
