/**
 */
package de.mdelab.mlcallactions.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.ocl.pivot.evaluation.Executor;
import org.eclipse.ocl.pivot.ids.TypeId;
import org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation;
import org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation;
import org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation;
import org.eclipse.ocl.pivot.utilities.PivotUtil;
import org.eclipse.ocl.pivot.utilities.ValueUtil;
import org.eclipse.ocl.pivot.values.IntegerValue;
import org.eclipse.ocl.pivot.values.TupleValue;
import de.mdelab.mlcallactions.MlcallactionsPackage;
import de.mdelab.mlcallactions.MlcallactionsTables;
import de.mdelab.mlcallactions.VariableDeclarationAction;
import de.mdelab.mlcore.MLNamedElement;
import de.mdelab.mlcore.MlcorePackage;
import de.mdelab.mlexpressions.MLExpression;
import java.lang.reflect.InvocationTargetException;
import java.util.Map;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Variable Declaration Action</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.mdelab.mlcallactions.impl.VariableDeclarationActionImpl#getName <em>Name</em>}</li>
 *   <li>{@link de.mdelab.mlcallactions.impl.VariableDeclarationActionImpl#getValueExpression <em>Value Expression</em>}</li>
 * </ul>
 *
 * @generated
 */
public class VariableDeclarationActionImpl extends CallActionImpl implements VariableDeclarationAction {
	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getValueExpression() <em>Value Expression</em>}' containment reference.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @see #getValueExpression()
	 * @generated
	 * @ordered
	 */
	protected MLExpression valueExpression;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected VariableDeclarationActionImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MlcallactionsPackage.Literals.VARIABLE_DECLARATION_ACTION;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlcallactionsPackage.VARIABLE_DECLARATION_ACTION__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public MLExpression getValueExpression() {
		return valueExpression;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetValueExpression(MLExpression newValueExpression, NotificationChain msgs) {
		MLExpression oldValueExpression = valueExpression;
		valueExpression = newValueExpression;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET,
					MlcallactionsPackage.VARIABLE_DECLARATION_ACTION__VALUE_EXPRESSION, oldValueExpression,
					newValueExpression);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setValueExpression(MLExpression newValueExpression) {
		if (newValueExpression != valueExpression) {
			NotificationChain msgs = null;
			if (valueExpression != null)
				msgs = ((InternalEObject) valueExpression).eInverseRemove(this,
						EOPPOSITE_FEATURE_BASE - MlcallactionsPackage.VARIABLE_DECLARATION_ACTION__VALUE_EXPRESSION,
						null, msgs);
			if (newValueExpression != null)
				msgs = ((InternalEObject) newValueExpression).eInverseAdd(this,
						EOPPOSITE_FEATURE_BASE - MlcallactionsPackage.VARIABLE_DECLARATION_ACTION__VALUE_EXPRESSION,
						null, msgs);
			msgs = basicSetValueExpression(newValueExpression, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlcallactionsPackage.VARIABLE_DECLARATION_ACTION__VALUE_EXPRESSION, newValueExpression,
					newValueExpression));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean nameSpecified(final DiagnosticChain diagnostics, final Map<Object, Object> context) {
		final String constraintName = "VariableDeclarationAction::nameSpecified";
		try {
			/**
			 *
			 * inv nameSpecified:
			 *   let severity : Integer[1] = constraintName.getSeverity()
			 *   in
			 *     if severity <= 0
			 *     then true
			 *     else
			 *       let
			 *         result : OclAny[1] = let status : Boolean[1] = self.name <> null
			 *         in
			 *           if status = true
			 *           then true
			 *           else Tuple{message = 'name must be specified.', status = status}
			 *           endif
			 *       in
			 *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
			 *     endif
			 */
			final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this, context);
			final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE.evaluate(executor,
					MlcallactionsPackage.Literals.VARIABLE_DECLARATION_ACTION___NAME_SPECIFIED__DIAGNOSTICCHAIN_MAP);
			final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
					.evaluate(executor, severity_0, MlcallactionsTables.INT_0).booleanValue();
			/*@NonInvalid*/ boolean symbol_2;
			if (le) {
				symbol_2 = true;
			} else {
				final /*@NonInvalid*/ String name = this.getName();
				final /*@NonInvalid*/ boolean status = name != null;
				/*@NonInvalid*/ Object symbol_1;
				if (status) {
					symbol_1 = ValueUtil.TRUE_VALUE;
				} else {
					final /*@NonInvalid*/ TupleValue symbol_0 = ValueUtil.createTupleOfEach(MlcallactionsTables.TUPLid_,
							MlcallactionsTables.STR_name_32_must_32_be_32_specified, status);
					symbol_1 = symbol_0;
				}
				final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
						.evaluate(executor, TypeId.BOOLEAN, constraintName, this, (Object) null, diagnostics, context,
								(Object) null, severity_0, symbol_1, MlcallactionsTables.INT_0)
						.booleanValue();
				symbol_2 = logDiagnostic;
			}
			return symbol_2;
		} catch (Throwable e) {
			return ValueUtil.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean typeSpecified(final DiagnosticChain diagnostics, final Map<Object, Object> context) {
		final String constraintName = "VariableDeclarationAction::typeSpecified";
		try {
			/**
			 *
			 * inv typeSpecified:
			 *   let severity : Integer[1] = constraintName.getSeverity()
			 *   in
			 *     if severity <= 0
			 *     then true
			 *     else
			 *       let
			 *         result : OclAny[1] = let status : Boolean[1] = self.type <> null
			 *         in
			 *           if status = true
			 *           then true
			 *           else Tuple{message = 'type must be specified.', status = status}
			 *           endif
			 *       in
			 *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
			 *     endif
			 */
			final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this, context);
			final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE.evaluate(executor,
					MlcallactionsPackage.Literals.VARIABLE_DECLARATION_ACTION___TYPE_SPECIFIED__DIAGNOSTICCHAIN_MAP);
			final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
					.evaluate(executor, severity_0, MlcallactionsTables.INT_0).booleanValue();
			/*@NonInvalid*/ boolean symbol_2;
			if (le) {
				symbol_2 = true;
			} else {
				final /*@NonInvalid*/ EClassifier type = this.getType();
				final /*@NonInvalid*/ boolean status = type != null;
				/*@NonInvalid*/ Object symbol_1;
				if (status) {
					symbol_1 = ValueUtil.TRUE_VALUE;
				} else {
					final /*@NonInvalid*/ TupleValue symbol_0 = ValueUtil.createTupleOfEach(MlcallactionsTables.TUPLid_,
							MlcallactionsTables.STR_type_32_must_32_be_32_specified, status);
					symbol_1 = symbol_0;
				}
				final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
						.evaluate(executor, TypeId.BOOLEAN, constraintName, this, (Object) null, diagnostics, context,
								(Object) null, severity_0, symbol_1, MlcallactionsTables.INT_0)
						.booleanValue();
				symbol_2 = logDiagnostic;
			}
			return symbol_2;
		} catch (Throwable e) {
			return ValueUtil.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean valueExpressionSpecified(final DiagnosticChain diagnostics, final Map<Object, Object> context) {
		final String constraintName = "VariableDeclarationAction::valueExpressionSpecified";
		try {
			/**
			 *
			 * inv valueExpressionSpecified:
			 *   let severity : Integer[1] = constraintName.getSeverity()
			 *   in
			 *     if severity <= 0
			 *     then true
			 *     else
			 *       let
			 *         result : OclAny[1] = let status : Boolean[1] = self.valueExpression <> null
			 *         in
			 *           if status = true
			 *           then true
			 *           else
			 *             Tuple{message = 'valueExpression must be specified.', status = status
			 *             }
			 *           endif
			 *       in
			 *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
			 *     endif
			 */
			final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this, context);
			final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE.evaluate(executor,
					MlcallactionsPackage.Literals.VARIABLE_DECLARATION_ACTION___VALUE_EXPRESSION_SPECIFIED__DIAGNOSTICCHAIN_MAP);
			final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
					.evaluate(executor, severity_0, MlcallactionsTables.INT_0).booleanValue();
			/*@NonInvalid*/ boolean symbol_0;
			if (le) {
				symbol_0 = true;
			} else {
				final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
						.evaluate(executor, TypeId.BOOLEAN, constraintName, this, (Object) null, diagnostics, context,
								(Object) null, severity_0, ValueUtil.TRUE_VALUE, MlcallactionsTables.INT_0)
						.booleanValue();
				symbol_0 = logDiagnostic;
			}
			return symbol_0;
		} catch (Throwable e) {
			return ValueUtil.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
		case MlcallactionsPackage.VARIABLE_DECLARATION_ACTION__VALUE_EXPRESSION:
			return basicSetValueExpression(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case MlcallactionsPackage.VARIABLE_DECLARATION_ACTION__NAME:
			return getName();
		case MlcallactionsPackage.VARIABLE_DECLARATION_ACTION__VALUE_EXPRESSION:
			return getValueExpression();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case MlcallactionsPackage.VARIABLE_DECLARATION_ACTION__NAME:
			setName((String) newValue);
			return;
		case MlcallactionsPackage.VARIABLE_DECLARATION_ACTION__VALUE_EXPRESSION:
			setValueExpression((MLExpression) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case MlcallactionsPackage.VARIABLE_DECLARATION_ACTION__NAME:
			setName(NAME_EDEFAULT);
			return;
		case MlcallactionsPackage.VARIABLE_DECLARATION_ACTION__VALUE_EXPRESSION:
			setValueExpression((MLExpression) null);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case MlcallactionsPackage.VARIABLE_DECLARATION_ACTION__NAME:
			return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
		case MlcallactionsPackage.VARIABLE_DECLARATION_ACTION__VALUE_EXPRESSION:
			return valueExpression != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == MLNamedElement.class) {
			switch (derivedFeatureID) {
			case MlcallactionsPackage.VARIABLE_DECLARATION_ACTION__NAME:
				return MlcorePackage.ML_NAMED_ELEMENT__NAME;
			default:
				return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == MLNamedElement.class) {
			switch (baseFeatureID) {
			case MlcorePackage.ML_NAMED_ELEMENT__NAME:
				return MlcallactionsPackage.VARIABLE_DECLARATION_ACTION__NAME;
			default:
				return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	@SuppressWarnings("unchecked")
	public Object eInvoke(int operationID, EList<?> arguments) throws InvocationTargetException {
		switch (operationID) {
		case MlcallactionsPackage.VARIABLE_DECLARATION_ACTION___NAME_SPECIFIED__DIAGNOSTICCHAIN_MAP:
			return nameSpecified((DiagnosticChain) arguments.get(0), (Map<Object, Object>) arguments.get(1));
		case MlcallactionsPackage.VARIABLE_DECLARATION_ACTION___TYPE_SPECIFIED__DIAGNOSTICCHAIN_MAP:
			return typeSpecified((DiagnosticChain) arguments.get(0), (Map<Object, Object>) arguments.get(1));
		case MlcallactionsPackage.VARIABLE_DECLARATION_ACTION___VALUE_EXPRESSION_SPECIFIED__DIAGNOSTICCHAIN_MAP:
			return valueExpressionSpecified((DiagnosticChain) arguments.get(0), (Map<Object, Object>) arguments.get(1));
		}
		return super.eInvoke(operationID, arguments);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuilder result = new StringBuilder(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(')');
		return result.toString();
	}

} // VariableDeclarationActionImpl
